<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { onMounted, watch, ref, onBeforeUnmount } from 'vue';
import { storeToRefs } from 'pinia';
import { useRoute, useRouter } from 'vue-router';
import { useI18n } from 'vue-i18n';
import { useTitle } from '@vueuse/core';
import { useChatStore } from '@/stores/chat';
import AdminLayout from '@/components/general/AdminLayout.vue';
import NavigationContent from '@/components/chat/NavigationContent.vue';
import MobileNavigation from '@/components/chat/NavigationMobile.vue';
import CreateChatModal from '@/components/chat/CreatorModalChat.vue';
import CreatePersonModal from '@/components/chat/CreatorModalPerson.vue';
import DeletePersonModal from '@/components/chat/DeleteModalPerson.vue';
import DeleteChatModal from '@/components/chat/DeleteModalChat.vue';
import CreateImageModal from '@/components/chat/CreatorModalmage.vue';
import StartPersonChatModal from '@/components/chat/CreatorModalChatPerson.vue';
import CopyChatModal from '@/components/chat/CopyChatModal.vue';

const chatStore = useChatStore();
const { tab, chats, state, uuid, activeChatUuid } = storeToRefs(chatStore);
const { getChats } = chatStore;
const router = useRouter();
const route = useRoute();
const title = useTitle();
const { t } = useI18n();
const $t = t;
 
title.value = $t('ai.general.variables.pageTitle.general')

const showSidebar = ref(false);

onMounted(async () => {
    getChats();
    showSidebar.value = window.innerWidth >= 640;
    window.addEventListener('resize', handleResize);
});

onBeforeUnmount(() => {
    window.removeEventListener('resize', handleResize);
});

const handleResize = () => {
    showSidebar.value = window.innerWidth >= 640;
};

const handleSubmitCreateRenameCopyChatModal = async (uuid: string | undefined) => {
    const type = state.value.includes("PERSON_CHAT_") ? "person" : state.value.includes("IMAGE_") ? "image" : "chat";
    handleCloseModals();
    if (uuid) {
        activeChatUuid.value = uuid;
        tab.value = type;
        router.push({ path: '/overview/chat/' + uuid });
    }
};

const handleCloseModals = () => {
    state.value = '';
    uuid.value = '';
};

watch(() => route.params.uuid, (newVal, oldVal) => {
    if (typeof oldVal !== 'undefined' && typeof newVal === 'undefined') {
        getChats();
    }
});

watch(() => state.value, (newVal, oldVal) => {
    if (['CHAT_CREATE', 'CHAT_EDIT', 'CHAT_DELETE', 'IMAGE_CREATE', 'IMAGE_EDIT', 'IMAGE_DELETE', 'PERSON_CHAT_CREATE', 'CHAT_COPY', 'IMAGE_COPY', 'PERSON_CHAT_COPY', 'PERSON_CREATE', 'PERSON_EDIT'].includes(oldVal) && newVal === '') {
        getChats();
        if (oldVal === 'PERSON_CREATE')
            router.push({path: '/overview/chat/persons'});
    }
});


const handleSubmitDeleteChat = () => {
    if (route.params.uuid == uuid.value) {
        router.push({ path: '/overview/chat' });
    }
    handleCloseModals();
};


</script>
<template>
    <AdminLayout>
        <template #navbarmenu>
            <MobileNavigation />
        </template>
        <div class="min-h-[calc(100dvh-80px)] max-h-[calc(100dvh-80px)] flex flex-col">
            <div class="flex flex-row h-full w-screen max-w-screen grow">
                <div class="h-full w-56" :class="tab === 'chat' ? 'bg-blue-50' : tab === 'person' ? 'bg-teal-50' : 'bg-orange-50'"
                    v-if="showSidebar">
                    <NavigationContent />
                </div>
                <div class="grow p-8 w-screen sm:max-w-[calc(100dvw-14rem)]">
                    <router-view></router-view>
                </div>
            </div>
        </div>
    </AdminLayout>
    <CreateChatModal v-if="(state === 'CHAT_CREATE' || state === 'CHAT_EDIT')"
        @submit="handleSubmitCreateRenameCopyChatModal" @close="handleCloseModals" />
    <CreatePersonModal v-if="(state === 'PERSON_CREATE' || state === 'PERSON_EDIT')" @submit="handleCloseModals"
        @close="handleCloseModals" />
    <DeletePersonModal v-if="(state === 'PERSON_DELETE')" @submit="handleCloseModals" @close="handleCloseModals" />
    <DeleteChatModal v-if="state === 'CHAT_DELETE'" @submit="handleSubmitDeleteChat" @close="handleCloseModals" />
    <CreateImageModal v-if="(state === 'IMAGE_CREATE' || state === 'IMAGE_EDIT')"
        @submit="handleSubmitCreateRenameCopyChatModal" @close="handleCloseModals" />
    <StartPersonChatModal v-if="(state === 'PERSON_CHAT_CREATE' || state === 'PERSON_CHAT_EDIT')"
        @submit="handleSubmitCreateRenameCopyChatModal" @close="handleCloseModals" />
    <CopyChatModal @close="handleCloseModals" @submit="handleSubmitCreateRenameCopyChatModal"
        v-if="(state === 'CHAT_COPY' || state === 'PERSON_CHAT_COPY' || state === 'IMAGE_COPY')" />
</template>
